diff -urN ../v2.2.21-ds8/linux/net/sched/sch_dsmark.c linux/net/sched/sch_dsmark.c
--- ../v2.2.21-ds8/linux/net/sched/sch_dsmark.c	Wed Jul 31 03:00:59 2002
+++ linux/net/sched/sch_dsmark.c	Sun Mar 31 06:18:30 2002
@@ -1,11 +1,13 @@
 /* net/sched/sch_dsmark.c - Differentiated Services field marker */
 
-/* Written 1998,1999 by Werner Almesberger, EPFL ICA */
+/* Written 1998-2000 by Werner Almesberger, EPFL ICA */
 
 
 #include <linux/config.h>
 #include <linux/module.h>
 #include <linux/types.h>
+#include <linux/string.h>
+#include <linux/errno.h>
 #include <linux/skbuff.h>
 #include <linux/netdevice.h> /* for pkt_sched */
 #include <linux/rtnetlink.h>
@@ -39,16 +41,22 @@
  *   x:y y>0	 y+1		use entry [y]
  *   ...	 ...		...
  * x:indices-1	indices		use entry [indices-1]
+ *   ...	 ...		...
+ *   x:y	 y+1		use entry [y & (indices-1)]
+ *   ...	 ...		...
+ * 0xffff	0x10000		use entry [indices-1]
  */
 
 
+#define NO_DEFAULT_INDEX	(1 << 16)
+
 struct dsmark_qdisc_data {
 	struct Qdisc		*q;
 	struct tcf_proto	*filter_list;
 	__u8			*mask;	/* "owns" the array */
 	__u8			*value;
 	__u16			indices;
-	__u16			default_index;
+	__u32			default_index;	/* index range is 0...0xffff */
 	int			set_tc_index;
 };
 
@@ -63,22 +71,28 @@
 
 	DPRINTK("dsmark_graft(sch %p,[qdisc %p],new %p,old %p)\n",sch,p,new,
 	    old);
-	if (!new) new = &noop_qdisc;
+	if (!new)
+		new = &noop_qdisc;
+	sch_tree_lock(sch);
 	*old = xchg(&p->q,new);
-	if (*old) qdisc_reset(*old);
+	if (*old)
+		qdisc_reset(*old);
+	sch_tree_unlock(sch); /* @@@ move up ? */
         return 0;
 }
 
 
 static struct Qdisc *dsmark_leaf(struct Qdisc *sch, unsigned long arg)
 {
-	return NULL;
+	struct dsmark_qdisc_data *p = PRIV(sch);
+
+	return p->q;
 }
 
 
 static unsigned long dsmark_get(struct Qdisc *sch,u32 classid)
 {
-	struct dsmark_qdisc_data *p = PRIV(sch);
+	struct dsmark_qdisc_data *p __attribute__((unused)) = PRIV(sch);
 
 	DPRINTK("dsmark_get(sch %p,[qdisc %p],classid %x)\n",sch,p,classid);
 	return TC_H_MIN(classid)+1;
@@ -106,9 +120,11 @@
 
 	DPRINTK("dsmark_change(sch %p,[qdisc %p],classid %x,parent %x),"
 	    "arg 0x%lx\n",sch,p,classid,parent,*arg);
-	if (*arg > p->indices) return -ENOENT;
-	if (!opt || rtattr_parse(tb,TCA_DSMARK_MAX,RTA_DATA(opt),
-	    RTA_PAYLOAD(opt))) return -EINVAL;
+	if (*arg > p->indices)
+		return -ENOENT;
+	if (!opt || rtattr_parse(tb, TCA_DSMARK_MAX, RTA_DATA(opt),
+				 RTA_PAYLOAD(opt)))
+		return -EINVAL;
 	if (tb[TCA_DSMARK_MASK-1]) {
 		if (!RTA_PAYLOAD(tb[TCA_DSMARK_MASK-1]))
 			return -EINVAL;
@@ -127,7 +143,8 @@
 {
 	struct dsmark_qdisc_data *p = PRIV(sch);
 
-	if (!arg || arg > p->indices) return -EINVAL;
+	if (!arg || arg > p->indices)
+		return -EINVAL;
 	p->mask[arg-1] = 0xff;
 	p->value[arg-1] = 0;
 	return 0;
@@ -140,14 +157,17 @@
 	int i;
 
 	DPRINTK("dsmark_walk(sch %p,[qdisc %p],walker %p)\n",sch,p,walker);
-	if (walker->stop) return;
+	if (walker->stop)
+		return;
 	for (i = 0; i < p->indices; i++) {
-		if (p->mask[i] == 0xff && !p->value[i]) continue;
-		if (walker->count >= walker->skip)
-			if (walker->fn(sch,i+1,walker) < 0) {
+		if (p->mask[i] == 0xff && !p->value[i])
+			continue;
+		if (walker->count >= walker->skip) {
+			if (walker->fn(sch, i+1, walker) < 0) {
 				walker->stop = 1;
 				break;
 			}
+		}
                 walker->count++;
         }
 }
@@ -169,9 +189,10 @@
 	struct dsmark_qdisc_data *p = PRIV(sch);
 	struct tcf_result res;
 	int result;
+	int ret = NET_XMIT_POLICED;
 
 	D2PRINTK("dsmark_enqueue(skb %p,sch %p,[qdisc %p])\n",skb,sch,p);
-	if (p->set_tc_index)
+	if (p->set_tc_index) {
 		switch (skb->protocol) {
 			case __constant_htons(ETH_P_IP):
 				skb->tc_index = ipv4_get_dsfield(skb->nh.iph);
@@ -181,11 +202,13 @@
 				break;
 			default:
 				skb->tc_index = 0;
-		}
+				break;
+		};
+	}
 	result = TC_POLICE_OK; /* be nice to gcc */
-	if (TC_H_MAJ(skb->priority) == sch->handle)
+	if (TC_H_MAJ(skb->priority) == sch->handle) {
 		skb->tc_index = TC_H_MIN(skb->priority);
-	else {
+	} else {
 		result = tc_classify(skb,p->filter_list,&res);
 		D2PRINTK("result %d class 0x%04x\n",result,res.classid);
 		switch (result) {
@@ -204,23 +227,24 @@
 			case TC_POLICE_UNSPEC:
 				/* fall through */
 			default:
-				if (p->default_index)
+				if (p->default_index != NO_DEFAULT_INDEX)
 					skb->tc_index = p->default_index;
 				break;
-		}
+		};
 	}
 	if (
 #ifdef CONFIG_NET_CLS_POLICE
 	    result == TC_POLICE_SHOT ||
 #endif
-	    p->q->enqueue(skb,p->q) != 1) {
+
+	    ((ret = p->q->enqueue(skb,p->q)) != 0)) {
 		sch->stats.drops++;
-		return 0;
+		return ret;
 	}
 	sch->stats.bytes += skb->len;
 	sch->stats.packets++;
 	sch->q.qlen++;
-	return 1;
+	return ret;
 }
 
 
@@ -232,7 +256,8 @@
 
 	D2PRINTK("dsmark_dequeue(sch %p,[qdisc %p])\n",sch,p);
 	skb = p->q->ops->dequeue(p->q);
-	if (!skb) return NULL;
+	if (!skb)
+		return NULL;
 	sch->q.qlen--;
 	index = skb->tc_index & (p->indices-1);
 	D2PRINTK("index %d->%d\n",skb->tc_index,index);
@@ -253,9 +278,10 @@
 			 */
 			if (p->mask[index] != 0xff || p->value[index])
 				printk(KERN_WARNING "dsmark_dequeue: "
-				    "unsupported protocol %d\n",
-				    htons(skb->protocol));
-	}
+				       "unsupported protocol %d\n",
+				       htons(skb->protocol));
+			break;
+	};
 	return skb;
 }
 
@@ -266,13 +292,12 @@
 	struct dsmark_qdisc_data *p = PRIV(sch);
 
 	D2PRINTK("dsmark_requeue(skb %p,sch %p,[qdisc %p])\n",skb,sch,p);
-	if ((ret = p->q->ops->requeue(skb, p->q)) == 0) {
+        if ((ret = p->q->ops->requeue(skb, p->q)) == 0) {
 		sch->q.qlen++;
-		return 1;
+		return 0;
 	}
 	sch->stats.drops++;
-	return ret;  
-
+	return ret;
 }
 
 
@@ -281,8 +306,10 @@
 	struct dsmark_qdisc_data *p = PRIV(sch);
 
 	DPRINTK("dsmark_reset(sch %p,[qdisc %p])\n",sch,p);
-	if (!p->q->ops->drop) return 0;
-	if (!p->q->ops->drop(p->q)) return 0;
+	if (!p->q->ops->drop)
+		return 0;
+	if (!p->q->ops->drop(p->q))
+		return 0;
 	sch->q.qlen--;
 	return 1;
 }
@@ -295,32 +322,34 @@
 	__u16 tmp;
 
 	DPRINTK("dsmark_init(sch %p,[qdisc %p],opt %p)\n",sch,p,opt);
-	if (rtattr_parse(tb,TCA_DSMARK_MAX,RTA_DATA(opt),RTA_PAYLOAD(opt)) < 0
-	    || !tb[TCA_DSMARK_INDICES-1] ||
+	if (rtattr_parse(tb,TCA_DSMARK_MAX,RTA_DATA(opt),RTA_PAYLOAD(opt)) < 0 ||
+	    !tb[TCA_DSMARK_INDICES-1] ||
 	    RTA_PAYLOAD(tb[TCA_DSMARK_INDICES-1]) < sizeof(__u16))
                 return -EINVAL;
 	memset(p,0,sizeof(*p));
 	p->filter_list = NULL;
 	p->indices = *(__u16 *) RTA_DATA(tb[TCA_DSMARK_INDICES-1]);
-	if (!p->indices) return -EINVAL;
-	for (tmp = p->indices; tmp != 1; tmp >>= 1)
-		if (tmp & 1) return -EINVAL;
-	p->default_index = 0;
+	if (!p->indices)
+		return -EINVAL;
+	for (tmp = p->indices; tmp != 1; tmp >>= 1) {
+		if (tmp & 1)
+			return -EINVAL;
+	}
+	p->default_index = NO_DEFAULT_INDEX;
 	if (tb[TCA_DSMARK_DEFAULT_INDEX-1]) {
 		if (RTA_PAYLOAD(tb[TCA_DSMARK_DEFAULT_INDEX-1]) < sizeof(__u16))
 			return -EINVAL;
 		p->default_index =
 		    *(__u16 *) RTA_DATA(tb[TCA_DSMARK_DEFAULT_INDEX-1]);
-		if (!p->default_index || p->default_index >= p->indices)
-			return -EINVAL;
 	}
 	p->set_tc_index = !!tb[TCA_DSMARK_SET_TC_INDEX-1];
 	p->mask = kmalloc(p->indices*2,GFP_KERNEL);
-	if (!p->mask) return -ENOMEM;
+	if (!p->mask)
+		return -ENOMEM;
 	p->value = p->mask+p->indices;
 	memset(p->mask,0xff,p->indices);
 	memset(p->value,0,p->indices);
-	if (!(p->q = qdisc_create_dflt(sch->dev,&pfifo_qdisc_ops)))
+	if (!(p->q = qdisc_create_dflt(sch->dev, &pfifo_qdisc_ops)))
 		p->q = &noop_qdisc;
 	DPRINTK("dsmark_init: qdisc %p\n",&p->q);
 	MOD_INC_USE_COUNT;
@@ -356,8 +385,6 @@
 }
 
 
-#ifdef CONFIG_RTNETLINK
-
 static int dsmark_dump_class(struct Qdisc *sch, unsigned long cl,
     struct sk_buff *skb, struct tcmsg *tcm)
 {
@@ -366,7 +393,8 @@
 	struct rtattr *rta;
 
 	DPRINTK("dsmark_dump_class(sch %p,[qdisc %p],class %ld\n",sch,p,cl);
-	if (!cl || cl > p->indices) return -EINVAL;
+	if (!cl || cl > p->indices)
+		return -EINVAL;
 	tcm->tcm_handle = TC_H_MAKE(TC_H_MAJ(sch->handle),cl-1);
 	rta = (struct rtattr *) b;
 	RTA_PUT(skb,TCA_OPTIONS,0,NULL);
@@ -389,10 +417,13 @@
 	rta = (struct rtattr *) b;
 	RTA_PUT(skb,TCA_OPTIONS,0,NULL);
 	RTA_PUT(skb,TCA_DSMARK_INDICES,sizeof(__u16),&p->indices);
-	if (p->default_index)
-		RTA_PUT(skb,TCA_DSMARK_DEFAULT_INDEX,sizeof(__u16),
-		    &p->default_index);
-	if (p->set_tc_index) RTA_PUT(skb,TCA_DSMARK_SET_TC_INDEX,0,NULL);
+	if (p->default_index != NO_DEFAULT_INDEX) {
+		__u16 tmp = p->default_index;
+
+		RTA_PUT(skb,TCA_DSMARK_DEFAULT_INDEX, sizeof(__u16), &tmp);
+	}
+	if (p->set_tc_index)
+		RTA_PUT(skb, TCA_DSMARK_SET_TC_INDEX, 0, NULL);
 	rta->rta_len = skb->tail-b;
 	return skb->len;
 
@@ -401,9 +432,6 @@
 	return -1;
 }
 
-#endif
-
-
 static struct Qdisc_class_ops dsmark_class_ops =
 {
 	dsmark_graft,			/* graft */
@@ -418,9 +446,7 @@
 	dsmark_bind_filter,		/* bind_tcf */
 	dsmark_put,			/* unbind_tcf */
 
-#ifdef CONFIG_RTNETLINK
 	dsmark_dump_class,		/* dump */
-#endif
 };
 
 struct Qdisc_ops dsmark_qdisc_ops =
@@ -440,9 +466,7 @@
 	dsmark_destroy,			/* destroy */
 	NULL,				/* change */
 
-#ifdef CONFIG_RTNETLINK
 	dsmark_dump			/* dump */
-#endif
 };
 
 #ifdef MODULE
@@ -457,3 +481,4 @@
 	unregister_qdisc(&dsmark_qdisc_ops);
 }
 #endif
+MODULE_LICENSE("GPL");
diff -urN ../v2.2.21-ds8/linux/net/sched/sch_fifo.c linux/net/sched/sch_fifo.c
--- ../v2.2.21-ds8/linux/net/sched/sch_fifo.c	Sat Oct 21 15:10:47 2000
+++ linux/net/sched/sch_fifo.c	Sun Mar 31 06:18:30 2002
@@ -51,14 +51,14 @@
 		sch->stats.backlog += skb->len;
 		sch->stats.bytes += skb->len;
 		sch->stats.packets++;
-		return 1;
+		return 0;
 	}
 	sch->stats.drops++;
 #ifdef CONFIG_NET_CLS_POLICE
 	if (sch->reshape_fail==NULL || sch->reshape_fail(skb, sch))
 #endif
 		kfree_skb(skb);
-	return 0;
+	return NET_XMIT_DROP;
 }
 
 static int
@@ -66,7 +66,7 @@
 {
 	__skb_queue_head(&sch->q, skb);
 	sch->stats.backlog += skb->len;
-	return 1;
+	return 0;
 }
 
 static struct sk_buff *
@@ -110,21 +110,21 @@
 		__skb_queue_tail(&sch->q, skb);
 		sch->stats.bytes += skb->len;
 		sch->stats.packets++;
-		return 1;
+		return 0;
 	}
 	sch->stats.drops++;
 #ifdef CONFIG_NET_CLS_POLICE
 	if (sch->reshape_fail==NULL || sch->reshape_fail(skb, sch))
 #endif
 		kfree_skb(skb);
-	return 0;
+	return NET_XMIT_DROP;
 }
 
 static int
 pfifo_requeue(struct sk_buff *skb, struct Qdisc* sch)
 {
 	__skb_queue_head(&sch->q, skb);
-	return 1;
+	return 0;
 }
 
 
@@ -152,7 +152,6 @@
 	return 0;
 }
 
-#ifdef CONFIG_RTNETLINK
 static int fifo_dump(struct Qdisc *sch, struct sk_buff *skb)
 {
 	struct fifo_sched_data *q = (void*)sch->data;
@@ -168,7 +167,6 @@
 	skb_trim(skb, b - skb->data);
 	return -1;
 }
-#endif
 
 struct Qdisc_ops pfifo_qdisc_ops =
 {
@@ -187,9 +185,7 @@
 	NULL,
 	fifo_init,
 
-#ifdef CONFIG_RTNETLINK
 	fifo_dump,
-#endif
 };
 
 struct Qdisc_ops bfifo_qdisc_ops =
@@ -208,7 +204,5 @@
 	fifo_reset,
 	NULL,
 	fifo_init,
-#ifdef CONFIG_RTNETLINK
 	fifo_dump,
-#endif
 };
diff -urN ../v2.2.21-ds8/linux/net/sched/sch_generic.c linux/net/sched/sch_generic.c
--- ../v2.2.21-ds8/linux/net/sched/sch_generic.c	Wed Jul 31 03:00:59 2002
+++ linux/net/sched/sch_generic.c	Thu Aug  8 02:26:44 2002
@@ -32,8 +32,6 @@
 #include <net/sock.h>
 #include <net/pkt_sched.h>
 
-#define BUG_TRAP(x) if (!(x)) { printk("Assertion (" #x ") failed at " __FILE__ "(%d):" __FUNCTION__ "\n", __LINE__); }
-
 /* Main transmission queue. */
 
 struct Qdisc_head qdisc_head = { &qdisc_head };
@@ -151,7 +149,7 @@
 noop_enqueue(struct sk_buff *skb, struct Qdisc * qdisc)
 {
 	kfree_skb(skb);
-	return 0;
+	return NET_XMIT_CN;
 }
 
 static struct sk_buff *
@@ -166,7 +164,7 @@
 	if (net_ratelimit())
 		printk(KERN_DEBUG "%s deferred output. It is buggy.\n", skb->dev->name);
 	kfree_skb(skb);
-	return 0;
+	return NET_XMIT_CN;
 }
 
 struct Qdisc_ops noop_qdisc_ops =
@@ -208,7 +206,7 @@
 {
         { NULL }, 
 	NULL,
-	NULL,
+	noop_dequeue,
 	TCQ_F_BUILTIN,
 	&noqueue_qdisc_ops,
 };
@@ -229,14 +227,14 @@
 	list = ((struct sk_buff_head*)qdisc->data) +
 		prio2band[skb->priority&TC_PRIO_MAX];
 
-	if (list->qlen <= skb->dev->tx_queue_len) {
+	if (list->qlen <= qdisc->dev->tx_queue_len) {
 		__skb_queue_tail(list, skb);
 		qdisc->q.qlen++;
-		return 1;
+		return 0;
 	}
 	qdisc->stats.drops++;
 	kfree_skb(skb);
-	return 0;
+	return NET_XMIT_DROP;
 }
 
 static struct sk_buff *
@@ -266,7 +264,7 @@
 
 	__skb_queue_head(list, skb);
 	qdisc->q.qlen++;
-	return 1;
+	return 0;
 }
 
 static void
@@ -334,52 +332,42 @@
 
 void qdisc_reset(struct Qdisc *qdisc)
 {
-	struct Qdisc_ops *ops;
+	struct Qdisc_ops *ops = qdisc->ops;
 
-	if ((qdisc==NULL)||(NULL==(ops = qdisc->ops)))
-		goto bye;	
-	start_bh_atomic();
 	if (ops->reset)
 		ops->reset(qdisc);
-
-	end_bh_atomic();
-bye:
 }
 
 void qdisc_destroy(struct Qdisc *qdisc)
 {
-	struct Qdisc_ops *ops;
-
-	if ((qdisc==NULL)||(NULL==(ops = qdisc->ops)))
-		goto bye;	
+	struct Qdisc_ops *ops = qdisc->ops;
+	struct device *dev;
 
 	if (!atomic_dec_and_test(&qdisc->refcnt))
 		return;
 
+	dev = qdisc->dev;
+
 #ifdef CONFIG_NET_SCHED
-	if (qdisc->dev) {
+	if (dev) {
 		struct Qdisc *q, **qp;
-		for (qp = &qdisc->dev->qdisc_list; (q=*qp) != NULL; qp = &q->next)
+		for (qp = &qdisc->dev->qdisc_list; (q=*qp) != NULL; qp = &q->next) {
 			if (q == qdisc) {
 				*qp = q->next;
-				q->next = NULL;
 				break;
 			}
+		}
 	}
 #ifdef CONFIG_NET_ESTIMATOR
 	qdisc_kill_estimator(&qdisc->stats);
 #endif
 #endif
-	start_bh_atomic();
 	if (ops->reset)
 		ops->reset(qdisc);
-
 	if (ops->destroy)
 		ops->destroy(qdisc);
-	end_bh_atomic();
 	if (!(qdisc->flags&TCQ_F_BUILTIN))
 		kfree(qdisc);
-bye:
 }
 
 
@@ -392,19 +380,20 @@
 	 */
 
 	if (dev->qdisc_sleeping == &noop_qdisc) {
+		struct Qdisc *qdisc;
 		if (dev->tx_queue_len) {
-			struct Qdisc *qdisc;
 			qdisc = qdisc_create_dflt(dev, &pfifo_fast_ops);
 			if (qdisc == NULL) {
 				printk(KERN_INFO "%s: activation failed\n", dev->name);
 				return;
 			}
-			dev->qdisc_sleeping = qdisc;
-		} else
-			dev->qdisc_sleeping = &noqueue_qdisc;
+		} else {
+			qdisc =  &noqueue_qdisc;
+		}
+		dev->qdisc_sleeping = qdisc;
 	}
 
-	start_bh_atomic();
+	sch_dev_queue_lock(dev);
 	if ((dev->qdisc = dev->qdisc_sleeping) != &noqueue_qdisc) {
 		dev->qdisc->tx_timeo = 5*HZ;
 		dev->qdisc->tx_last = jiffies - dev->qdisc->tx_timeo;
@@ -412,16 +401,17 @@
 			dev_watchdog.expires = jiffies + 5*HZ;
 		add_timer(&dev_watchdog);
 	}
-	end_bh_atomic();
+	sch_dev_queue_unlock(dev);
 }
 
 void dev_deactivate(struct device *dev)
 {
 	struct Qdisc *qdisc;
 
-	start_bh_atomic();
+	sch_dev_queue_lock(dev);
 
-	qdisc = xchg(&dev->qdisc, &noop_qdisc);
+	qdisc = dev->qdisc;
+	dev->qdisc = &noop_qdisc;
 
 	qdisc_reset(qdisc);
 
@@ -437,7 +427,7 @@
 		}
 	}
 
-	end_bh_atomic();
+	sch_dev_queue_unlock(dev);
 }
 
 void dev_init_scheduler(struct device *dev)
@@ -451,20 +441,16 @@
 {
 	struct Qdisc *qdisc;
 
-	start_bh_atomic();
+	sch_dev_queue_lock(dev);
 	qdisc = dev->qdisc_sleeping;
 	dev->qdisc = &noop_qdisc;
 	dev->qdisc_sleeping = &noop_qdisc;
 	qdisc_destroy(qdisc);
-#ifdef CONFIG_NET_SCH_INGRESS
-	if (dev->qdisc_ingress) {
-	qdisc = dev->qdisc_ingress;
-	qdisc_destroy(qdisc);
-	}
-#endif
+        if ((qdisc = dev->qdisc_ingress) != NULL) {
+		dev->qdisc_ingress = NULL;
+		qdisc_destroy(qdisc);
+        }
 	BUG_TRAP(dev->qdisc_list == NULL);
 	dev->qdisc_list = NULL;
-	dev->qdisc_ingress = NULL;
-	end_bh_atomic();
+	sch_dev_queue_unlock(dev);
 }
-
diff -urN ../v2.2.21-ds8/linux/net/sched/sch_gred.c linux/net/sched/sch_gred.c
--- ../v2.2.21-ds8/linux/net/sched/sch_gred.c	Wed Jul 31 03:00:59 2002
+++ linux/net/sched/sch_gred.c	Sat Jun 14 09:49:14 2003
@@ -7,7 +7,7 @@
  *              as published by the Free Software Foundation; either version
  *              2 of the License, or (at your option) any later version.
  *
- * Authors:    J Hadi Salim (hadi@nortelnetworks.com) 1998,1999
+ * Authors:    J Hadi Salim (hadi@cyberus.ca) 1998-2002
  *
  *             991129: -  Bug fix with grio mode
  *		       - a better sing. AvgQ mode with Grio(WRED)
@@ -67,7 +67,7 @@
 	u32		limit;		/* HARD maximal queue length	*/
 	u32		qth_min;	/* Min average length threshold: A scaled */
 	u32		qth_max;	/* Max average length threshold: A scaled */
-        u32      	DP;		/* the drop pramaters */
+	u32      	DP;		/* the drop pramaters */
 	char		Wlog;		/* log(W)		*/
 	char		Plog;		/* random number bits	*/
 	u32		Scell_max;
@@ -110,16 +110,13 @@
 	unsigned long	qave=0;	
 	int i=0;
 
-	if (!t->initd) {
-		DPRINTK("NO GRED Queues setup yet! Enqueued anyway\n");
-		if (q->backlog <= q->limit) {
-			__skb_queue_tail(&sch->q, skb);
-			return 1;
-		}
+	if (!t->initd && skb_queue_len(&sch->q) <= sch->dev->tx_queue_len) {
+		D2PRINTK("NO GRED Queues setup yet! Enqueued anyway\n");
+		goto do_enqueue;
 	}
 
 
-	if ( ((skb->tc_index&0xf) > t->DPs) || !(q=t->tab[skb->tc_index&0xf])) {
+	if ( ((skb->tc_index&0xf) > (t->DPs -1)) || !(q=t->tab[skb->tc_index&0xf])) {
 		printk("GRED: setting to default (%d)\n ",t->def);
 		if (!(q=t->tab[t->def])) {
 			DPRINTK("GRED: setting to default FAILED! dropping!! "
@@ -146,8 +143,8 @@
 			
 	}
 
-        q->packetsin++;
-        q->bytesin+=skb->len;
+	q->packetsin++;
+	q->bytesin+=skb->len;
 
 	if (t->eqp && t->grio) {
 		qave=0;
@@ -179,12 +176,13 @@
 		q->qcount = -1;
 enqueue:
 		if (q->backlog <= q->limit) {
+			q->backlog += skb->len;
+do_enqueue:
 			__skb_queue_tail(&sch->q, skb);
 			sch->stats.backlog += skb->len;
 			sch->stats.bytes += skb->len;
 			sch->stats.packets++;
-			q->backlog += skb->len;
-			return 1;
+			return 0;
 		} else {
 			q->pdrop++;
 		}
@@ -192,7 +190,7 @@
 drop:
 		kfree_skb(skb);
 		sch->stats.drops++;
-		return 0;
+		return NET_XMIT_DROP;
 	}
 	if ((q->qave+qave) >= q->qth_max) {
 		q->qcount = -1;
@@ -218,14 +216,14 @@
 {
 	struct gred_sched_data *q;
 	struct gred_sched *t= (struct gred_sched *)sch->data;
-        q= t->tab[(skb->tc_index&0xf)];
+	q= t->tab[(skb->tc_index&0xf)];
 /* error checking here -- probably unnecessary */
 	PSCHED_SET_PASTPERFECT(q->qidlestart);
 
 	__skb_queue_head(&sch->q, skb);
 	sch->stats.backlog += skb->len;
 	q->backlog += skb->len;
-	return 1;
+	return 0;
 }
 
 static struct sk_buff *
@@ -300,14 +298,12 @@
 
 static void gred_reset(struct Qdisc* sch)
 {
-	struct sk_buff *skb;
 	int i;
-
 	struct gred_sched_data *q;
 	struct gred_sched *t= (struct gred_sched *)sch->data;
 
-	while((skb=__skb_dequeue(&sch->q))!=NULL)
-		kfree_skb(skb);
+	__skb_queue_purge(&sch->q);
+
 	sch->stats.backlog = 0;
 
         for (i=0;i<t->DPs;i++) {
@@ -329,27 +325,29 @@
 {
 	struct gred_sched *table = (struct gred_sched *)sch->data;
 	struct gred_sched_data *q;
-        struct tc_gred_qopt *ctl;
-        struct tc_gred_sopt *sopt;
-        struct rtattr *tb[TCA_GRED_STAB];
-        struct rtattr *tb2[TCA_GRED_STAB];
+	struct tc_gred_qopt *ctl;
+	struct tc_gred_sopt *sopt;
+	struct rtattr *tb[TCA_GRED_STAB];
+	struct rtattr *tb2[TCA_GRED_DPS];
 	int i;
 
-        if (opt == NULL ||
-            rtattr_parse(tb, TCA_GRED_STAB, RTA_DATA(opt), RTA_PAYLOAD(opt)) )
-                return -EINVAL;
+	if (opt == NULL ||
+		rtattr_parse(tb, TCA_GRED_STAB, RTA_DATA(opt), RTA_PAYLOAD(opt)) )
+			return -EINVAL;
 
-	if (tb[TCA_GRED_PARMS-1] == 0 && tb[TCA_GRED_STAB-1] == 0 &&
-	    tb[TCA_GRED_DPS-1] != 0) {
+	if (tb[TCA_GRED_PARMS-1] == 0 && tb[TCA_GRED_STAB-1] == 0) {
 		rtattr_parse(tb2, TCA_GRED_DPS, RTA_DATA(opt),
 		    RTA_PAYLOAD(opt));
 
-	    	sopt = RTA_DATA(tb2[TCA_GRED_DPS-1]);
-	    	table->DPs=sopt->DPs;   
-	    	table->def=sopt->def_DP; 
-	    	table->grio=sopt->grio; 
+		if (tb2[TCA_GRED_DPS-1] == 0)
+			return -EINVAL;
+
+		sopt = RTA_DATA(tb2[TCA_GRED_DPS-1]);
+		table->DPs=sopt->DPs;   
+		table->def=sopt->def_DP; 
+		table->grio=sopt->grio; 
 		table->initd=0;
-                /* probably need to clear all the table DP entries as well */
+		/* probably need to clear all the table DP entries as well */
 		MOD_INC_USE_COUNT;
 		return 0;
 	    }
@@ -361,7 +359,7 @@
 			return -EINVAL;
 
 	ctl = RTA_DATA(tb[TCA_GRED_PARMS-1]);
-	if (ctl->DP > MAX_DPs-1 || ctl->DP <0) {
+	if (ctl->DP > MAX_DPs-1 ) {
 		/* misbehaving is punished! Put in the default drop probability */
 		DPRINTK("\nGRED: DP %u not in  the proper range fixed. New DP "
 			"set to default at %d\n",ctl->DP,table->def);
@@ -371,6 +369,8 @@
 	if (table->tab[ctl->DP] == NULL) {
 		table->tab[ctl->DP]=kmalloc(sizeof(struct gred_sched_data),
 					    GFP_KERNEL);
+		if (NULL == table->tab[ctl->DP])
+			return -ENOMEM;
 		memset(table->tab[ctl->DP], 0, (sizeof(struct gred_sched_data)));
 	}
 	q= table->tab[ctl->DP]; 
@@ -378,13 +378,13 @@
 	if (table->grio) {
 		if (ctl->prio <=0) {
 			if (table->def && table->tab[table->def]) {
-				DPRINTK("\nGRED: DP %u does not have a prio setting "
-					"default to %d\n",ctl->DP,
+				DPRINTK("\nGRED: DP %u does not have a prio"
+					"setting default to %d\n",ctl->DP,
 					table->tab[table->def]->prio);
 				q->prio=table->tab[table->def]->prio;
 			} else { 
-				DPRINTK("\nGRED: DP %u does not have a prio setting "
-					"default to 8\n",ctl->DP);
+				DPRINTK("\nGRED: DP %u does not have a prio"
+					" setting default to 8\n",ctl->DP);
 				q->prio=8;
 			}
 		} else {
@@ -392,7 +392,7 @@
 		}
 	} else {
 		q->prio=8;
-        }
+	}
 
 
 	q->DP=ctl->DP;
@@ -437,10 +437,13 @@
 
 		if (table->tab[table->def] == NULL) {
 			table->tab[table->def]=
-			    kmalloc(sizeof(struct gred_sched_data), GFP_KERNEL);
+				kmalloc(sizeof(struct gred_sched_data), GFP_KERNEL);
+			if (NULL == table->tab[table->def])
+				return -ENOMEM;
+
 			memset(table->tab[table->def], 0,
 			       (sizeof(struct gred_sched_data)));
-                }
+		}
 		q= table->tab[table->def]; 
 		q->DP=table->def;
 		q->Wlog = ctl->Wlog;
@@ -452,54 +455,54 @@
 		q->qth_min = ctl->qth_min<<ctl->Wlog;
 		q->qth_max = ctl->qth_max<<ctl->Wlog;
 
-                if (table->grio)
+		if (table->grio)
 			q->prio=table->tab[ctl->DP]->prio;
-                else
+		else
 			q->prio=8;
 
 		q->qcount = -1;
 		PSCHED_SET_PASTPERFECT(q->qidlestart);
 		memcpy(q->Stab, RTA_DATA(tb[TCA_GRED_STAB-1]), 256);
 	}
-        return 0;
+	return 0;
 
 }
 
 static int gred_init(struct Qdisc *sch, struct rtattr *opt)
 {
 	struct gred_sched *table = (struct gred_sched *)sch->data;
-        struct tc_gred_sopt *sopt;
-        struct rtattr *tb[TCA_GRED_STAB];
-        struct rtattr *tb2[TCA_GRED_STAB];
-
-        if (opt == NULL ||
-            rtattr_parse(tb, TCA_GRED_STAB, RTA_DATA(opt), RTA_PAYLOAD(opt)) )
-                return -EINVAL;
+	struct tc_gred_sopt *sopt;
+	struct rtattr *tb[TCA_GRED_STAB];
+	struct rtattr *tb2[TCA_GRED_DPS];
 
-	if (tb[TCA_GRED_PARMS-1] == 0 && tb[TCA_GRED_STAB-1] == 0 &&
-	    tb[TCA_GRED_DPS-1] != 0) {
-		rtattr_parse(tb2, TCA_GRED_DPS, RTA_DATA(opt),
-		    RTA_PAYLOAD(opt));
+	if (opt == NULL ||
+		rtattr_parse(tb, TCA_GRED_STAB, RTA_DATA(opt), RTA_PAYLOAD(opt)) )
+			return -EINVAL;
+
+	if (tb[TCA_GRED_PARMS-1] == 0 && tb[TCA_GRED_STAB-1] == 0 ) {
+		rtattr_parse(tb2, TCA_GRED_DPS, RTA_DATA(opt),RTA_PAYLOAD(opt));
+
+		if (tb2[TCA_GRED_DPS-1] == 0)
+			return -EINVAL;
 
-	    	sopt = RTA_DATA(tb2[TCA_GRED_DPS-1]);
-	    	table->DPs=sopt->DPs;   
-	    	table->def=sopt->def_DP; 
-	    	table->grio=sopt->grio; 
+		sopt = RTA_DATA(tb2[TCA_GRED_DPS-1]);
+		table->DPs=sopt->DPs;   
+		table->def=sopt->def_DP; 
+		table->grio=sopt->grio; 
 		table->initd=0;
 		MOD_INC_USE_COUNT;
 		return 0;
 	}
 
-        DPRINTK("\n GRED_INIT error!\n");
+	DPRINTK("\n GRED_INIT error!\n");
 	return -EINVAL;
 }
 
-#ifdef CONFIG_RTNETLINK
 static int gred_dump(struct Qdisc *sch, struct sk_buff *skb)
 {
 	unsigned long qave;
 	struct rtattr *rta;
-	struct tc_gred_qopt *opt;
+	struct tc_gred_qopt *opt = NULL ;
 	struct tc_gred_qopt *dst;
 	struct gred_sched *table = (struct gred_sched *)sch->data;
 	struct gred_sched_data *q;
@@ -512,7 +515,7 @@
 	opt=kmalloc(sizeof(struct tc_gred_qopt)*MAX_DPs, GFP_KERNEL);
 
 	if (opt  == NULL) {
-		DPRINTK("gred_dump:failed to malloc for %d\n",
+		DPRINTK("gred_dump:failed to malloc for %Zd\n",
 		    sizeof(struct tc_gred_qopt)*MAX_DPs);
 		goto rtattr_failure;
 	}
@@ -521,7 +524,6 @@
 
 	if (!table->initd) {
 		DPRINTK("NO GRED Queues setup!\n");
-		return -1;
 	}
 
 	for (i=0;i<MAX_DPs;i++) {
@@ -578,16 +580,18 @@
 	RTA_PUT(skb, TCA_GRED_PARMS, sizeof(struct tc_gred_qopt)*MAX_DPs, opt);
 	rta->rta_len = skb->tail - b;
 
+	kfree(opt);
 	return skb->len;
 
 rtattr_failure:
+	if (opt)
+		kfree(opt);
 	DPRINTK("gred_dump: FAILURE!!!!\n");
 
 /* also free the opt struct here */
 	skb_trim(skb, b - skb->data);
 	return -1;
 }
-#endif
 
 static void gred_destroy(struct Qdisc *sch)
 {
@@ -615,9 +619,7 @@
 	gred_reset,
 	gred_destroy,
 	gred_change, /* change */
-#ifdef CONFIG_RTNETLINK
 	gred_dump,
-#endif
 };
 
 
@@ -632,3 +634,4 @@
 	unregister_qdisc(&gred_qdisc_ops);
 }
 #endif
+MODULE_LICENSE("GPL");
diff -urN ../v2.2.21-ds8/linux/net/sched/sch_ingress.c linux/net/sched/sch_ingress.c
--- ../v2.2.21-ds8/linux/net/sched/sch_ingress.c	Wed Jul 31 03:00:59 2002
+++ linux/net/sched/sch_ingress.c	Sun Aug  4 21:02:57 2002
@@ -13,14 +13,15 @@
 #include <net/pkt_sched.h>
 #include <asm/byteorder.h>
 
+#undef DEBUG_INGRESS
 
-#if 1 /* control */
+#ifdef DEBUG_INGRESS  /* control */
 #define DPRINTK(format,args...) printk(KERN_DEBUG format,##args)
 #else
 #define DPRINTK(format,args...)
 #endif
 
-#if 0 /* data */
+#if 0  /* data */
 #define D2PRINTK(format,args...) printk(KERN_DEBUG format,##args)
 #else
 #define D2PRINTK(format,args...)
@@ -43,10 +44,12 @@
 static int ingress_graft(struct Qdisc *sch,unsigned long arg,
     struct Qdisc *new,struct Qdisc **old)
 {
+#ifdef DEBUG_INGRESS
 	struct ingress_qdisc_data *p = PRIV(sch);
+#endif
 
-	DPRINTK("ingress_graft(sch %p,[qdisc %p],new %p,old %p)\n",sch,p,new,
-	    old);
+	DPRINTK("ingress_graft(sch %p,[qdisc %p],new %p,old %p)\n",
+		sch, p, new, old);
 	DPRINTK("\n ingress_graft: You cannot add qdiscs to classes");
         return 1;
 }
@@ -60,17 +63,18 @@
 
 static unsigned long ingress_get(struct Qdisc *sch,u32 classid)
 {
+#ifdef DEBUG_INGRESS
 	struct ingress_qdisc_data *p = PRIV(sch);
-
-	DPRINTK("ingress_get(sch %p,[qdisc %p],classid %x)\n",sch,p,classid);
-	return TC_H_MIN(classid)+1;
+#endif
+	DPRINTK("ingress_get(sch %p,[qdisc %p],classid %x)\n", sch, p, classid);
+	return TC_H_MIN(classid) + 1;
 }
 
 
 static unsigned long ingress_bind_filter(struct Qdisc *sch,
     unsigned long parent, u32 classid)
 {
-	return ingress_get(sch,classid);
+	return ingress_get(sch, classid);
 }
 
 
@@ -82,10 +86,11 @@
 static int ingress_change(struct Qdisc *sch, u32 classid, u32 parent,
     struct rtattr **tca, unsigned long *arg)
 {
+#ifdef DEBUG_INGRESS
 	struct ingress_qdisc_data *p = PRIV(sch);
-
+#endif
 	DPRINTK("ingress_change(sch %p,[qdisc %p],classid %x,parent %x),"
-	    "arg 0x%lx\n",sch,p,classid,parent,*arg);
+		"arg 0x%lx\n", sch, p, classid, parent, *arg);
 	DPRINTK("No effect. sch_ingress doesnt maintain classes at the moment");
 	return 0;
 }
@@ -94,9 +99,10 @@
 
 static void ingress_walk(struct Qdisc *sch,struct qdisc_walker *walker)
 {
+#ifdef DEBUG_INGRESS
 	struct ingress_qdisc_data *p = PRIV(sch);
-
-	DPRINTK("ingress_walk(sch %p,[qdisc %p],walker %p)\n",sch,p,walker);
+#endif
+	DPRINTK("ingress_walk(sch %p,[qdisc %p],walker %p)\n", sch, p, walker);
 	DPRINTK("No effect. sch_ingress doesnt maintain classes at the moment");
 }
 
@@ -118,32 +124,34 @@
 	struct tcf_result res;
 	int result;
 
-	D2PRINTK("ingress_enqueue(skb %p,sch %p,[qdisc %p])\n",skb,sch,p);
-
-	result = tc_classify(skb,p->filter_list,&res);
-	D2PRINTK("result %d class 0x%04x\n",result,res.classid);
+	D2PRINTK("ingress_enqueue(skb %p,sch %p,[qdisc %p])\n", skb, sch, p);
+	result = tc_classify(skb, p->filter_list, &res);
+	D2PRINTK("result %d class 0x%04x\n", result, res.classid);
 	/*
 	 * Unlike normal "enqueue" functions, ingress_enqueue returns a
 	 * firewall FW_* code.
 	 */
-	switch (result) {
 #ifdef CONFIG_NET_CLS_POLICE
+	switch (result) {
 		case TC_POLICE_SHOT:
 			result = FW_BLOCK;
+			sch->stats.drops++;
 			break;
 		case TC_POLICE_RECLASSIFY: /* DSCP remarking here ? */
 		case TC_POLICE_OK:
 		case TC_POLICE_UNSPEC:
 		default:
+			sch->stats.packets++;
+			sch->stats.bytes += skb->len;
 			result = FW_ACCEPT;
 			break;
-#endif
-		}
-
-#ifdef CONFIG_NET_CLS_TCINDEX
-         skb->tc_index = TC_H_MIN(res.classid);
+	};
+#else
+	sch->stats.packets++;
+	sch->stats.bytes += skb->len;
 #endif
 
+	skb->tc_index = TC_H_MIN(res.classid);
 	return result;
 }
 
@@ -152,8 +160,8 @@
 {
 /*
 	struct ingress_qdisc_data *p = PRIV(sch);
-*/
 	D2PRINTK("ingress_dequeue(sch %p,[qdisc %p])\n",sch,PRIV(p));
+*/
 	return NULL;
 }
 
@@ -162,16 +170,17 @@
 {
 /*
 	struct ingress_qdisc_data *p = PRIV(sch);
-*/
 	D2PRINTK("ingress_requeue(skb %p,sch %p,[qdisc %p])\n",skb,sch,PRIV(p));
+*/
 	return 0;
 }
 
 static int ingress_drop(struct Qdisc *sch)
 {
+#ifdef DEBUG_INGRESS
 	struct ingress_qdisc_data *p = PRIV(sch);
-
-	DPRINTK("ingress_drop(sch %p,[qdisc %p])\n",sch,p);
+#endif
+	DPRINTK("ingress_drop(sch %p,[qdisc %p])\n", sch, p);
 	return 0;
 }
 
@@ -181,10 +190,9 @@
 	struct ingress_qdisc_data *p = PRIV(sch);
 
 	DPRINTK("ingress_init(sch %p,[qdisc %p],opt %p)\n",sch,p,opt);
-	memset(p,0,sizeof(*p));
+	memset(p, 0, sizeof(*p));
 	p->filter_list = NULL;
-	p->q=NULL;
-	DPRINTK("ingress_init: qdisc %p\n",sch);
+	p->q = &noop_qdisc;
 	MOD_INC_USE_COUNT;
 	return 0;
 }
@@ -194,13 +202,16 @@
 {
 	struct ingress_qdisc_data *p = PRIV(sch);
 
-	DPRINTK("ingress_reset(sch %p,[qdisc %p])\n",sch,p);
+	DPRINTK("ingress_reset(sch %p,[qdisc %p])\n", sch, p);
 
 /*
-	sch->ingress=0;
+#if 0
 */
 /* for future use */
 	qdisc_reset(p->q);
+/*
+#endif
+*/
 }
 
 
@@ -209,46 +220,40 @@
 	struct ingress_qdisc_data *p = PRIV(sch);
 	struct tcf_proto *tp;
 
-	DPRINTK("ingress_destroy(sch %p,[qdisc %p])\n",sch,p);
+	DPRINTK("ingress_destroy(sch %p,[qdisc %p])\n", sch, p);
 	while (p->filter_list) {
 		tp = p->filter_list;
 		p->filter_list = tp->next;
 		tp->ops->destroy(tp);
 	}
-	memset(p,0,sizeof(*p));
-        p->filter_list = NULL;
+	memset(p, 0, sizeof(*p));
+	p->filter_list = NULL;
 
+#if 0
 /* for future use */
 	qdisc_destroy(p->q);
-
+#endif
+ 
 	MOD_DEC_USE_COUNT;
-}
-
 
-#ifdef CONFIG_RTNETLINK
+}
 
 
 static int ingress_dump(struct Qdisc *sch, struct sk_buff *skb)
 {
-/*
-	struct ingress_qdisc_data *p = PRIV(sch);
-*/
 	unsigned char *b = skb->tail;
 	struct rtattr *rta;
 
 	rta = (struct rtattr *) b;
-	RTA_PUT(skb,TCA_OPTIONS,0,NULL);
-	rta->rta_len = skb->tail-b;
+	RTA_PUT(skb, TCA_OPTIONS, 0, NULL);
+	rta->rta_len = skb->tail - b;
 	return skb->len;
 
 rtattr_failure:
-	skb_trim(skb,b-skb->data);
+	skb_trim(skb, b - skb->data);
 	return -1;
 }
 
-#endif
-
-
 static struct Qdisc_class_ops ingress_class_ops =
 {
 	ingress_graft,			/* graft */
@@ -263,9 +268,7 @@
 	ingress_bind_filter,		/* bind_tcf */
 	ingress_put,			/* unbind_tcf */
 
-#ifdef CONFIG_RTNETLINK
 	NULL,		/* dump */
-#endif
 };
 
 struct Qdisc_ops ingress_qdisc_ops =
@@ -285,15 +288,21 @@
 	ingress_destroy,		/* destroy */
 	NULL,				/* change */
 
-#ifdef CONFIG_RTNETLINK
 	ingress_dump,			/* dump */
-#endif
 };
 
+
 #ifdef MODULE
 int init_module(void)
 {
-	return register_qdisc(&ingress_qdisc_ops);
+	int ret = 0;
+
+	if ((ret = register_qdisc(&ingress_qdisc_ops)) < 0) {
+		printk("Unable to register Ingress qdisc\n");
+		return ret;
+	}
+
+	return ret;
 }
 
 
